require(['jquery', 'manageContent', 'magicNumbers', 'touchevents', 'jqueryUI', 'touchPunch', 'labeledSlider'], function($, manageContent, magicNumbers) {

    window.out = function (string) {
        if (magicNumbers.environment === 'app') {
            var $body = $('body');
            if ($body.find('#out').length === 0) {
                $body.append('<div id="out"></div>');
            }
            $('#out').html('<b>' + string + '</b>').show();
        }
    };

    function setupConsole() {
        var area = document.createElement("textarea");
        area.id = "console";
        area.placeholder = "console.log() output will appear here";
        area.cols = "25";
        area.rows = "10";
        var body = document.getElementsByTagName("body")[0];
        body.insertBefore( area, body.firstChild);

        window.console.log = function(str) {
            area.value += str + '\n';
        };
    }


    // Platform detection
    var _PLATFORM = '';
    if (navigator.userAgent.match(/iPhone|iPad|iPod/i)) {
        if (navigator.userAgent.match(/(iPhone|iPad|iPod);.*CPU.*OS 7_\d/i)) {
            _PLATFORM = "iOS-7";
        } else {
            _PLATFORM = "iOS-6";
        }
        _PLATFORM += ' iOS';
    } else if (navigator.userAgent.match(/Android/i)) {
        _PLATFORM = "Android";
        magicNumbers.headerHeight = 44;
    } else {
        _PLATFORM = "browser";
    }

    if( _PLATFORM !== 'browser') {
        if (manageContent.isTablet()){
            screen.lockOrientation('landscape');
        } else {
            screen.lockOrientation('portrait');
        }
    }

    if (_PLATFORM !== "Android") {
        if(window.calabash){
            var success = function() {
            };

            var failure = function() {
            };

            calabash.start(success, failure);
        }
    }

    // Attach iOS version info to body tag to differenciate between iOS6 & 7 in CSS
    $('body').addClass(_PLATFORM);

    if (magicNumbers.environment === 'app') {
        setupConsole();
        window.addEventListener("load", setupConsole, false);
    }

    manageContent.initial();
    $('nav').css({ top: magicNumbers.headerHeight + 'px' });
    $('#content').css({ paddingTop: magicNumbers.headerHeight + 'px' });


    $('#overlay')
        .hide()
        .find('.messagebox').show();

    $(window).bind('orientationchange', function(event){
        manageContent.setContentHeight();
    });

});
