define([
        'jquery',
        'underscore',
        'magicNumbers',
        'text!../data/pages.json',
        'text!../data/Osteoporosis.json',
        'text!../data/Anticoagulation.json',
        'text!../data/Delirium.json',
        'text!../data/PainManagement.json',
        'text!../data/About.json',
        'text!../data/Terms.json',
        'notification',
        'slides'
    ],
    function ($, _, magicNumbers, pagesJson, Osteoporosis, Anticoagulation, Delirium, PainManagement, About, Terms, notification, slides) {

        var json = eval("(" + pagesJson + ")"), // all the infos about pages and where you can go from there
            topics = {
                Osteoporosis: eval("(" + Osteoporosis + ")"),
                Anticoagulation: eval("(" + Anticoagulation + ")"),
                Delirium: eval("(" + Delirium + ")"),
                PainManagement: eval("(" + PainManagement + ")"),
                About: eval("(" + About + ")"),
                Terms: eval("(" + Terms + ")")
            },
            mainTopic = '',
            currentPage,
            history = {
                Osteoporosis: [],
                Anticoagulation: [],
                Delirium: [],
                About: [],
                PainManagement: []
            },
            historyPop = function () {
                currentPage = history[mainTopic].pop();
                permanentStorage.setItem('history', JSON.stringify(history));
                permanentStorage.setItem('currentPage' + mainTopic, JSON.stringify(currentPage));
            },
            historyPush = function (nextPage) {
                history[mainTopic].push(currentPage);
                currentPage = nextPage;
                permanentStorage.setItem('history', JSON.stringify(history));
                permanentStorage.setItem('currentPage' + mainTopic, JSON.stringify(currentPage));

            },

        /* reset this more often? */
            isTablet = function () {
                // resolutions (320 * 480) (800) for iphone and (768 *1024 ) (1792) in iPad
                return window.innerWidth > 642; // (480+768)/2
            },

            permanentStorage = window.localStorage,

            $body = $('body'),
            $breadcrumb = $('#breadcrumb'),
            $toggleBreadcrumb = $('#toggleBreadcrumb'),
            $content = $('#content'),
            goingBackwards = false,
            contentHeight = 0,
            timeoutResume = false;

        function resumeTimeout() {
            timeoutResume = true;
            setTimeout(function () {
                timeoutResume = false;
            }, 200);
        }

        function buttons(childrenObj) {
            var html = '<div class="buttons">',
                array = [],
                children;

            if (typeof childrenObj === 'string') {
                children = topics[mainTopic][childrenObj]; // another branch is being trodden
            } else if (typeof childrenObj === "undefined") {
                children = topics[mainTopic];
            } else {
                children = childrenObj; // this node has his own children (standard)
            }

            _.each(children, function (obj, key) {
                array.push(key);
            });
            array.sort(); // the order the buttons are in is determined by sorting the keys alphabetically


            _.each(array, function (key) {
                var cssClass = key,
                    linktext = children[key].linktext,
                    linksubtext = '',
                    infotext = '',
                    template = '',
                    obj = children[key];

                if (typeof obj.linksubtext !== 'undefined') {
                    linksubtext = '<small>' + obj.linksubtext + '</small>';
                }

                if(typeof obj.infotext != 'undefined') {
                    infotext = '<span class="text-default">' + obj.infotext + '</span>';
                }

                if (typeof obj['buttonType'] !== 'undefined') {
                    cssClass += ' ' + obj['buttonType']; // yesno, back, toDashboard, backgroundInfo
                    if (obj['buttonType'] === 'back') {
                        linktext += ' to ' + obj['headline'];
                    }
                    if (obj['buttonType'] === 'backgroundInfo') {
                        $body.addClass('hasBackgroundInfoButton');
                    }
                }
                if (!obj['template']) { // some buttons have yet to receive children. this ist content to come
                    cssClass += ' inactive hidden'; // buttons without content led to empty list cells, so they are hidden.
                } else {
                    template = obj['template']; // toDo remove for customer. info for production
                }

                html += _.template(
                    $('#template-button').html(),
                    {
                        destination: key,
                        linktext: linktext,
                        infotext: infotext,
                        linksubtext: linksubtext,
                        cssClass: cssClass,
                        linkTitle: template  // todo remove, when PainManagement is there
                    }
                );
            });
            return {
                html: html + "</div><br />",
                array: array
            };
        }

        function furtherReadingLinks() {
            if (mainTopic !== '') {
                var naviLinks = '',
                    children = topics[mainTopic]['furtherReading'];
                _.each(children, function (obj, key) {
                    var cssClass = ' ' + key;
                    naviLinks += _.template(
                        $('#template-navi-link').html(),
                        {
                            destination: key,
                            linktext: obj.linktext,
                            cssClass: cssClass
                        }
                    );
                });
                return naviLinks;
            } else {
                return false;
            }

        }

        var scrollToTop = function () {
            $('html, body').scrollTop(0);
        };

        var hideBreadcrumb = function () {
            $body.removeClass('breadcrumb');
        };

        var getContent = function (page) {

            // you can load something other than the currentPage
            // (abbrevations or references for example)
            page = page || currentPage;

            $body
                .removeClass('hasBackgroundInfoButton')
                .removeClass('backgroundInfo');

            if (isTablet()) {
                $('#backgroundInfoLayer').hide();
            }

            try {
                require(['text!../data/' + mainTopic + '/' + page['template']], function (html) {
                    var gobacknumber = 'doesntmatter',
                        $container,
                        butons = buttons(page['children']); // this object has 2 elements "array" and "html"
                    if (mainTopic) {
                        gobacknumber = $content.find('.column').length; //history[mainTopic].length-1;
                    }

                    if (isTablet()) {
                        if (page['buttonType'] === 'backgroundInfo') {
                            var $backgroundInfoLayer = $('#backgroundInfoLayer'),
                                bginfolayerheight,
                                windowheight = $content.find('.column').height();
                            $backgroundInfoLayer.html(
                                _.template(html, {
                                    buttons: butons['html']
                                })
                            ).show();
                            bginfolayerheight = $backgroundInfoLayer.height();
                            if (bginfolayerheight < windowheight) {
                                $backgroundInfoLayer.height(windowheight);
                            } else {
                                $backgroundInfoLayer.height('');
                            }
                        }

                        else if(page['buttonType'] === 'painadInfo'){
                            var $painadInfoLayer = $('#painadInfoLayer'),
                                bginfolayerheight,
                                windowheight = $content.find('.column').height();
                            $painadInfoLayer.html(
                                _.template(html, {
                                    buttons: butons['html']
                                })
                            ).show();
                            bginfolayerheight = $painadInfoLayer.height();
                            if (bginfolayerheight < windowheight) {
                                $painadInfoLayer.height(windowheight);
                            } else {
                                $painadInfoLayer.height('');
                            }
                        }
                        else {
                            $content.append(
                                '<div class="column" data-goback="' + gobacknumber + '">' +
                                _.template(html, {
                                    buttons: butons['html']
                                }) +
                                '</div>'
                            );
                        }
                    } else {
                        $content.html('');
                        $content.append(
                            '<div class="column" data-goback="' + gobacknumber + '">' +
                            _.template(html, {
                                buttons: butons['html']
                            }) +
                            '</div>'
                        );
                    }

                    $container = $content.find('.column').last();
                    // butons['array'] is an array of strings
                    $.each(butons['array'], function () {
                        // if a button was manually placed inside the html
                        if ($container.find('.manually.' + this).length > 0) {
                            // the automatically generated equivalent is redundant
                            $('.buttons .' + this).hide(); // why doesn't this hide both the buttons (automatically and manually placed) ?
                        }
                    });

                    scrollToTop();
                    $toggleBreadcrumb.html(page['headline']);
                    setContentHeight();

                    slides.cosmeticsForAllSlides();
                    if (magicNumbers.environment !== 'live') {
                        slides.debugCosmetics();
                    }

                    // load javascript
                    if (typeof page['javascript'] !== 'undefined') {
                        // goingBackwards will become false after slides[page... is done
                        goingBackwards = slides[page['javascript']](goingBackwards);
                    }
                });
            } catch (e) {
                if (typeof(main) !== 'undefined') {
                    console.log('get Content: ' + e);
                    console.log('text!../data/' + main + '/' + page['template']);
                }

                reset(); // starting new at Dashboard
                getContent();
            }
        };

        var setMainTopic = function (topic) {
            var furtherReading;

            $body.removeClass(mainTopic);
            mainTopic = topic;

            if (mainTopic === '') {
                $body.addClass('Dashboard');
                if (window.location.hash !== '') {
                    window.location.hash = '';
                }
            } else {
                $body.addClass(mainTopic);
                if (window.location.hash !== '#' + mainTopic) {
                    window.location.hash = '#' + mainTopic;
                }
            }

            furtherReading = furtherReadingLinks();
            if (furtherReading) {
                $('#furtherReading').html('<h2>Further Reading</h2><ul>' +
                furtherReading +
                '</ul>');
            } else {
                $('#furtherReading').html('');
            }
        };

        var reset = function () {
            hideBreadcrumb();
            $content.html('');
            setMainTopic(''); // fills furtherReading

            history[mainTopic] = []; // wann wird reset aufgerufen?             resize
            currentPage = json[magicNumbers.dataEntryPoint]; // index.html
        };

        var setContentHeight = function () {
            if (isTablet()) {
                var navHeight = $('nav').outerHeight(true),
                    windowHgt = window.innerHeight, // padding-top and -bottom (why?)
                    $columns = $content.find('.column'),
                    $col1, $col2;


                if (windowHgt < navHeight) {
                    $content.css({minHeight: navHeight});
                } else {
                    $content.css({minHeight: '100%'});
                }

                contentHeight = 0;
                $col1 = $content.find('.column:nth-last-child(1)');
                $col2 = $content.find('.column:nth-last-child(2)');
                $col1.height('auto'); // removing previous heights ..
                $col2.height('auto'); // .. to measure the actual one
                if ($col1.outerHeight() > contentHeight) {
                    contentHeight = $col1.outerHeight();
                }
                if ($col2 && $col2.outerHeight() > contentHeight) {
                    contentHeight = $col2.outerHeight();
                }
                if (contentHeight < windowHgt) {
                    contentHeight = windowHgt;
                }

                contentHeight = contentHeight - magicNumbers.headerHeight - 63 - 15;

                $.each($columns, function () {
                    $(this).height(contentHeight);
                });
            }
        };
        var setContentHeightForBreadcrumb = function () {
            var bcHeight = $('#breadcrumb').outerHeight(true) + magicNumbers.headerHeight;

            if ($content.height() < bcHeight) {
                $content.css({minHeight: bcHeight});
            }
        };

        var view = function () {
            out(
                history[mainTopic].length + '<br />' +
                currentPage['headline']
            );
        };

        var searchForPath = function (data, path) {
            var foundObject = null;
            var finalResult;

                for (var key in data) {
                    if (key == path) {     // If the Item exists in the rawdata
                        return data[key];   // Return only the Matching Object
                    }
                    if (data[key] instanceof Object)
                        foundObject = searchForPath(data[key], path);
                        if(foundObject != null){
                         finalResult = foundObject;  // Fetch the value
                        }
                    }

            return finalResult;
        };


        var walkThisWay = function (path, callback) {
            var branch = 'children';
            hideBreadcrumb();

            var stepsToGoBack = -$content.find('.column').length - history[mainTopic].length;
            if (stepsToGoBack > 0) {
                goBackToSlideNumber(stepsToGoBack);
            } else {
                if (typeof currentPage[branch] === 'string') {
                    if (topics[mainTopic][currentPage[branch]][path] == undefined) {   // If the "path" is not found in the currentPage Children
                        var foundChild = searchForPath(topics[mainTopic], path);
                        historyPush(foundChild);
                    }else{
                        historyPush(topics[mainTopic][currentPage[branch]][path]); // switching to a new root-node
                    }
                } else {
                    if (currentPage[branch] == undefined || currentPage[branch][path] == undefined) {   // If the "path" is not found in the currentPage Children
                        var foundChild = searchForPath(topics[mainTopic], path);
                        historyPush(foundChild);
                    }
                    else{
                        historyPush(currentPage[branch][path]); // descending the current branch
                    }
                }
                getContent();
            }

            if (callback) {
                callback();
            }
        };

        var takeFirstStep = function (path) { // fresh from the dashboard

            setMainTopic(path); // which topic from the dashboard

            if (!history[path]) {
                history[path] = [];
            }

            if (history[path].length > 2) {
                // var restart = confirm('Restart the module? If you click Continue/OK, you will restart this module and lose your current location and data.'); // or false
                notification.open('<h3>Restart the module?</h3><p>If you click OK, you will restart this module and lose your current location and data.</p>', function (restart) {

                    if (restart) {
                        // a fresh start
                        history[path].length = 0; // empty the array
                        historyPush(topics[path]['index']); // save the Dashboard in history
                        view();
                        $content.html('');
                        $body.removeClass('Dashboard').addClass('restart'); // "restart" will be deleted in slides.js->cosmetics
                        getContent();
                    } else {
                        $body.removeClass('Dashboard');
                        if (isTablet()) {
                            $.each(history[path], function (index, item) {
                                // console.log(this['headline']);
                                if (this['headline'] !== 'Home') {
                                    getContent(item);
                                }
                            });
                        }
                        currentPage = permanentStorage.getItem('currentPage' + mainTopic);
                        if (currentPage !== null) {
                            currentPage = JSON.parse(currentPage);
                        }
                        getContent();
                        view();
                        resumeTimeout();
                    } // if else
                }); // notification

            } else {

                if (history)
                    history[path].length = 0; // empty the array

                historyPush(topics[path]['index']);
                view();
                $content.html('');
                $body.removeClass('Dashboard');
                getContent();
            }
        };

        var goBackToSlideNumber = function (number) {
            hideBreadcrumb();

            while (history[mainTopic].length > number) {
                historyPop();
                if (isTablet()) { // duplicate (see next function)
                    $content.find('.column:last').remove(); // only when breadcrumping (don't remove when interclicking)
                }
            }
            if (history[mainTopic].length === 0) {
                reset();
            }
            // back to Dashboard or always if we are on a phone
            if (!isTablet() || history[mainTopic].length === 0) {
                goingBackwards = true;
                getContent();
            }
            if (isTablet()) {
                $.each($content.find('.column:last').find('.button'), function () {
                    $(this).removeClass('path');
                });
                setContentHeight();
            }
            view();
        };

        return {

            isTablet: function () {
                return isTablet();
            },
            setContentHeight: function () {
                return setContentHeight();
            },
            // resetting the app
            initial: function (path) {

                if (!permanentStorage.getItem('registerButtonClicked')) {
                    $body.addClass('showRegisterButton');
                } else {
                    $body.removeClass('showRegisterButton');
                }

                if ($body.hasClass('notYetInitialized')) {
                    try {
                        // Retrieve the object from storage
                        var historyString = permanentStorage.getItem('history');
                        if (historyString !== null) {
                            history = JSON.parse(historyString);
                        }
                    } catch (e) {
                        // console.log('local storage has yet to be filled')
                    }
                    $body.removeClass('notYetInitialized');
                }

                reset();

                if (typeof path === 'string') { // clicked something inside <nav>
                    takeFirstStep(path);
                } else {
                    var acceptTerms = permanentStorage.getItem('acceptTerms');
                    if (acceptTerms === 'true') { // terms already accepted
                        getContent(); // show Dashboard
                        $('#header').show();
                        $('#register-button').css({
                            zIndex: 5
                        });
                        $content.css({
                            zIndex: ''
                        })
                    } else {
                        walkThisWay(
                            'acceptTerms',
                            function () { // callback
                                $body.addClass('backgroundInfo');
                            }
                        );
                    }

                }
            },

            closeBackgroundInfo: function () {
                var $backgroundInfoLayer = $('#backgroundInfoLayer');
                var $painadInfoLayer = $('#painadInfoLayer');
                if (isTablet()) {
                    $backgroundInfoLayer.hide();
                    $backgroundInfoLayer.html('');
                    $painadInfoLayer.hide();
                    $body.removeClass('backgroundInfo'); // change header back (hide #closebutton etc.)
                    historyPop();

                    // getContent(); // warum hatte ich das hier drin? das hat die doppelten spalten verursacht
                } else {
                    $content.css({zIndex: ''});
                    this.back();
                }

                $body.removeClass('inAppIframe');
                $backgroundInfoLayer.css({zIndex: ''});
                $painadInfoLayer.css({zIndex: ''});
                $content.css({zIndex: ''});
            },

            // tapped a .button
            path: function ($button, goBackToSlidNumber) {
                if (!timeoutResume) {
                    if (isTablet() && goBackToSlidNumber - history[mainTopic].length + 1 !== 0) {
                        goBackToSlideNumber(goBackToSlidNumber + 1);
                    }
                    if ($button.hasClass('backgroundInfo')) {
                        walkThisWay(
                            $button.data('destination'),
                            function () { // callback
                                $body.addClass('backgroundInfo');
                            }
                        );
                    } else {
                        $button.addClass('path');
                        walkThisWay($button.data('destination'));
                    }
                }
            },

            // tapped a .button on the dashboard or inside <nav>
            firstStep: function (path) {
                goingBackwards = false;
                takeFirstStep(path);
            },

            furtherReading: function (path) {
                hideBreadcrumb();
                historyPush(topics[mainTopic]['furtherReading'][path]);
                getContent();
            },

            // navigate backward through dropdown/breadcrumb
            goBackToSlideNumber: function (number) {
                goBackToSlideNumber(number);
            },

            // backbutton
            back: function () {
                if (history[mainTopic].length === 0) {
                    this.initial();
                } else {
                    goBackToSlideNumber(history[mainTopic].length - 1);
                }
            },

            resetGoingBackwards: function () {
                goingBackwards = false;
            },

            displayBreadcrumb: function () {
                if (history[mainTopic].length > 0) {
                    var html = '</ul>',
                        count = 0;
                    _.each(history[mainTopic], function (obj, key) {
                        var text = key === 0 ? 'Home' : obj['headline'];
                        if (text !== '') {
                            html = '<li data-key="' + key + '">' + count + '. ' + text + '</li>' + html;
                            count++;
                        }
                    });
                    $breadcrumb
                        .html('<ul>' + html)
                        .css({top: magicNumbers.headerHeight + 'px'});
                    setContentHeightForBreadcrumb();
                    scrollToTop();
                    $body.toggleClass('breadcrumb');
                }
            },
            hideBreadcrumb: function () {
                hideBreadcrumb();
            },

            linkClicked: function (href, script) {
                // every slide can have its own javascript
                if (script) {
                    slides[script]();
                }

                // todo push history or dont pop on close
                scrollToTop();

                if (navigator.userAgent.match(/iPhone|iPad|iPod/i)) {
                    //Open the link in external browser
                    var ref = cordova.InAppBrowser.open(href, '_system', 'location=yes');
                } else { // iFrame
                    var gobacknumber = 'doesntmatter';
                    if (mainTopic) {
                        gobacknumber = history[mainTopic].length - 1;
                    }
                    $body.addClass('inAppIframe');
                    if (isTablet()) {
                        $('#backgroundInfoLayer').html(
                            '<iframe id="iFrame" src="' + href + '" style="height: '+ $(window).innerHeight() +'px;"></iframe>'
                        ).show();
                    } else {
                        // history push
                        $content
                            .html('')
                            .append(
                            '<div class="column" style="padding: 0;height: 100%" data-goback="' + gobacknumber + '">' +
                            '<iframe id="iFrame" src="' + href + '" style="padding: 0; height: '+ $(window).innerHeight() +'px;"></iframe>' +
                            '</div>'
                        );
                    }
                }

            } // linkClicked()

        };
    });

