define(function() {
    var permanentStorage = window.localStorage;
    return {
        payload: {
            pay: 'load'
        },

        cosmeticsForAllSlides: function() {

            // the dt has to have the same height as the dd it is covering
            $('.unfold').each(function() {
                $(this).find('dt').each(function() {
                    var $this = $(this);
                    $this.height(
                        $this.next().height() + 'px'
                    );
                })
            });

            $.each($('label.checkbox'), function() {
                $this = $(this);

                // return if slide has already been prepared (backward navigation)
                if ($this.find('.yes,.no').length > 0) {
                    return;
                }

                height = $this.outerHeight(true);
                $this.append('<div class="yes" style="line-height: ' + height + 'px">Yes</div>');
                $this.append('<div class="no" style="line-height: ' + height + 'px">No</div>');
                $this.find('.yes').on('tap', function(event) {
                    event.stopPropagation();
                    $(this).parent().removeClass('unchecked').addClass('checked')
                    var $input = $('input#' + $(this).parent().attr('for'));
                    if (!$input.is(':checked')) {
                        $input.trigger('click');
                    }
                }).on('click', function(event) {
                    event.preventDefault();
                    return false;
                });

                $this.find('.no').on('tap', function(event) {
                    event.stopPropagation();
                    $(this).parent().removeClass('checked').addClass('unchecked');
                    var $input = $('input#' + $(this).parent().attr('for'));
                    if ($input.is(':checked')) {
                        $input.trigger('click');
                    }
                }).on('click', function(event) {
                    event.preventDefault();
                    return false;
                });

            });

            $("input:radio").off().on('change', function(event) {
                var name = $(this).attr('name');
                $('input[name=' + name + ']').next().removeClass('selected');
                $('input[name=' + name + ']:checked').next().addClass('selected');
            });

            if ($('body').hasClass('restart')) {
                this.payload['Anticoagulation_slide17'] = [];
                this.payload['Delirium_slide7_questions'] = [];
                this.payload['Delirium_slide7_suggestion'] = [];
                this.payload['Delirium_slide26'] = [];
                this.payload['Osteoporosis_slide30'] = [];
                this.payload['Osteoporosis_slide33'] = [];
                this.payload['Osteoporosis_slide31'] = [];
                $('body').removeClass('restart');
            }

            return true
        },

        // for when magicNumbers.environment != 'live'
        debugCosmetics: function() {
            $.each($('.button'), function() {
                $(this).attr('title', $(this).attr('data-destination'));
            });
        },

        acceptTerms: function() {
            // $('#content').css({ zIndex: 6 }); // wozu war das denn gut?
            $('#acceptTerms').on('tap', function() {
                permanentStorage.setItem('acceptTerms', 'true');
                $('nav').find('li.toDashboard').trigger('tap');
            })
        },

        accept_Anticoagulation: function(goingBackwards) {
            var accepted = permanentStorage.getItem('Anticoagulation_accepted');
            if (accepted === 'true' && !goingBackwards) {
                $('.AnticoagulationAppMenu').trigger('tap');
            }
            return false; // to set goingBackwards to false after completion
        },
        Anticoagulation_accepted: function() {
            permanentStorage.setItem('Anticoagulation_accepted', 'true');
        },

        accept_Osteoporosis: function(goingBackwards) {
            var accepted = permanentStorage.getItem('Osteoporosis_accepted');
            if (accepted === 'true' && !goingBackwards) {
                $('.iAccept').trigger('tap');
            }
            return false; // to set goingBackwards to false after completion
        },
        Osteoporosis_accepted: function() {
            permanentStorage.setItem('Osteoporosis_accepted', 'true');
        },

        accept_PainManagement: function(goingBackwards) {
            var accepted = permanentStorage.getItem('PainManagement_accepted');
            if (accepted === 'true' && !goingBackwards) {
                $('.iAccept').trigger('tap');
            }
            return false; // to set goingBackwards to false after completion
        },
        PainManagement_accepted: function() {
            permanentStorage.setItem('PainManagement_accepted', 'true');
        },

        registerButtonClicked: function() {
            setTimeout(
                function() {
                    $('body').removeClass('showRegisterButton');
                },
                5000
            );
            permanentStorage.setItem('registerButtonClicked', 'true');
        },

        Anticoagulation_slide17: function() {
            // alert('slide 17');

            var self = this,
                $scope = $('.checkboxes.Anticoagulation_17'),
                $inputs = $scope.find('input'),
                $sum = $('#sum'),
                $buttons = $('.button.aHighRisk, .button.bModerateRisk, .button.cLowRisk'),
                risk,
                payload = self.payload['Anticoagulation_slide17'],
                $clickboxen = $scope.find('.yes'),
                showSum = function(sum) {
                    $sum.html(sum);

                    $.each($buttons, function() {
                        $(this).removeClass('highlight');
                    });
                    switch (sum) {
                        case 1:
                        case 2:
                            risk = '.cLowRisk';
                            break;
                        case 3:
                        case 4:
                            risk = '.bModerateRisk';
                            break;
                        case 5:
                        case 6:
                            risk = '.aHighRisk';
                            break;
                        default:
                            risk = '.doesNotExist';
                    }
                    $('.button' + risk).addClass('highlight');

                }; // showSum()

            $.merge($clickboxen, $scope.find('.no'));

            // restore state of yes/no buttons
            if (typeof payload !== 'undefined') {
                if (typeof payload['yes'] !== 'undefined') {
                    $.each(payload['yes'], function() {
                        $scope.find('#' + this).attr('checked', true);
                        $scope.find('label[for="' + this + '"]').addClass('checked selected');
                    });
                }
                if (typeof payload['no'] !== 'undefined') {
                    $.each(payload['no'], function() {
                        $scope.find('#' + this).attr('checked', false);
                        $scope.find('label[for="' + this + '"]').addClass('unchecked');
                    });
                }
                showSum(payload['sum']);
            }


            $clickboxen.on('tap click', function() {
                console.log('tap', this);
                var save = {
                    'yes': [],
                    'no': [],
                    'sum': 0
                };

                $.each($inputs, function() {
                    if ($(this).is(':checked')) {
                        save['yes'].push($(this).attr('id'));
                    }
                    if ($(this).next().hasClass('unchecked')) {
                        save['no'].push($(this).attr('id'));
                    }
                });

                $.each($inputs, function() {
                    if ($(this).is(':checked')) {
                        save['sum'] += $(this).data('points');
                    }
                });

                showSum(save['sum']);

                self.payload['Anticoagulation_slide17'] = save;
            });

        },
        Delirium_slide7_questions: function() {
            var self = this,
                $checkboxes = $('.checkboxes.CAM'),
                $box1inputs = [
                    $checkboxes.find('input#ms'),
                    $checkboxes.find('input#nb'),
                    $checkboxes.find('input#fa')
                ],
                $question3 = $checkboxes.find('input#td'),
                $levelOfConsciousness = $checkboxes.find('input[name=co]:radio'),
                $replacementForCam = $('#replacementForCam');

            if (self.payload['Delirium_slide7_questions']) {
                var save = self.payload['Delirium_slide7_questions'];
                $.each(save, function() {
                    $checkboxes.find('#' + this).attr('checked', true);
                    $checkboxes.find('label[for="' + this + '"]').addClass('checked selected');
                });
            };

            $.each($checkboxes.find('input'), function() {
                $(this).on('change', function() {
                    var box1 = true,
                        qes3 = false,
                        levl = false;

                    var save = [];
                    $.each($checkboxes.find('input'), function() {
                        if ($(this).is(':checked')) {
                            save.push($(this).attr('id'));
                        }
                    });
                    self.payload['Delirium_slide7_questions'] = save;

                    $.each($box1inputs, function() {
                        if ($(this).is(':not(:checked)')) {
                            box1 = false;
                        }
                    });
                    qes3 = $question3.is(':checked');
                    $.each($levelOfConsciousness, function() {
                        if ($(this).is(':checked') && $(this).val() === '1') {
                            levl = true;
                        }
                    });
                    if (box1 && (qes3 || levl)) {
                        self.payload.Delirium_slide7_suggestion = 'yes';
                    } else {
                        self.payload.Delirium_slide7_suggestion = 'no';
                    }
                })
            });
        },
        Delirium_slide7_result: function() {
            if (this.payload.Delirium_slide7_suggestion === 'yes') {
                $('.s11no').hide();
            } else {
                $('.s15yes').hide();
            }
        },
        Delirium_slide26: function() {
            var self = this,
                $container = $('.checkboxes.Delirium_26'),
                $inputs = $container.find('input'),
                $sum = $('#sum'),
                $buttons = $('.button.aHighRisk, .button.cLowRisk'),
                risk,
                $clickboxen = $container.find('.yes'),
                payload = self.payload['Delirium_slide26'],

                showSum = function(sum) {
                    $sum.html(sum);

                    $.each($buttons, function() {
                        $(this).removeClass('highlight');
                    });
                    if (sum < 5) {
                        risk = '.cLowRisk';
                    } else {
                        risk = '.aHighRisk';
                    }

                    //
                    $('.button' + risk).addClass('highlight');

                }; // showSum()

            $.merge($clickboxen, $container.find('.no')); // one Array with all .yes and .no

            if (typeof payload !== 'undefined') {
                if (typeof payload['yes'] !== 'undefined') {
                    $.each(payload['yes'], function() {
                        $container.find('#' + this).attr('checked', true);
                        $container.find('label[for="' + this + '"]').addClass('checked selected');
                    });
                }
                if (typeof payload['no'] !== 'undefined') {
                    $.each(payload['no'], function() {
                        $container.find('#' + this).attr('checked', false);
                        $container.find('label[for="' + this + '"]').addClass('unchecked');
                    });
                }
                showSum(payload['sum']);
            }

            $.each($inputs, function() {
                $clickboxen.on('tap click', function() {

                    if ($(this).parent().attr('for') === 'age70') {
                        if ( $(this).hasClass('no') ) return;
                        $('#age85')
                            .attr('checked', false)
                            .next().removeClass('checked')
                            .addClass('unchecked');
                    };
                    if ($(this).parent().attr('for') === 'age85') {
                        if ( $(this).hasClass('no') ) return;
                        $('#age70')
                            .attr('checked', false)
                            .next().removeClass('checked')
                            .addClass('unchecked');
                    };
                    if ($(this).parent().attr('for') === 'cdtSmall') {
                        if ( $(this).hasClass('no') ) return;
                        $('#cdtBig')
                            .attr('checked', false)
                            .next().removeClass('checked')
                            .addClass('unchecked');
                    };
                    if ($(this).parent().attr('for') === 'cdtBig') {
                        if ( $(this).hasClass('no') ) return;
                        $('#cdtSmall')
                            .attr('checked', false)
                            .next().removeClass('checked')
                            .addClass('unchecked');
                    };


                    var save = {
                        'yes': [],
                        'no': [],
                        'sum': 0
                    };

                    $.each($inputs, function() {
                        if ($(this).is(':checked')) {
                            save['yes'].push($(this).attr('id'));
                        }
                        if ($(this).next().hasClass('unchecked')) {
                            save['no'].push($(this).attr('id'));
                        }
                    });

                    $.each($inputs, function() {
                        if ($(this).is(':checked')) {
                            save['sum'] += $(this).data('points');
                        }
                    });
                    showSum(save['sum']);

                    self.payload['Delirium_slide26'] = save;
                });
            })
        },
        Osteoporosis_slide30: function() {
            var self = this,
                $inputs = $('.checkboxes.Osteoporosis_30'),
                $yesnos = $inputs.find('input:checkbox'),
                $radios = $inputs.find('input:radio'),
                $sum = $('#sum'),
                $results = $('.result'),
                estimation,
                payload = self.payload['Osteoporosis_slide30'],
                $clickboxen = $inputs.find('.yes'),

                showSum30 = function(sum) {

                    $sum.html(sum);

                    $.each($results, function() {
                        $(this).removeClass('highlight');
                    });
                    if (sum === 0) {
                        estimation = '.Nocomorbidity';
                    } else if (sum <= 2) {
                        estimation = '.Minorormildcomorbidities';
                    } else if (sum <= 4) {
                        estimation = '.Mildorseverecomorbidities';
                    } else {
                        estimation = '.Severecomorbidities';
                    }

                    $('.result' + estimation).addClass('highlight');

                }; // showSum()

            $.merge($clickboxen, $inputs.find('.no'));
            $.merge($clickboxen, $inputs.find('label.radio'));

            if (typeof payload !== 'undefined') {
                if (typeof payload['yes'] !== 'undefined') {
                    $.each(payload['yes'], function() {
                        $inputs.find('#' + this).attr('checked', true);
                        $inputs.find('label[for="' + this + '"]').addClass('checked selected');
                    });
                }
                if (typeof payload['no'] !== 'undefined') {
                    $.each(payload['no'], function() {
                        $inputs.find('#' + this).attr('checked', false);
                        $inputs.find('label[for="' + this + '"]').addClass('unchecked');
                    });
                }
                showSum30(payload['sum']);
            }

            $.each($inputs, function() {

                $clickboxen.on('tap click', function() {
                    var save = {
                        'yes': [],
                        'no': [],
                        'sum': 0,
                    };

                    $.each($inputs.find('input'), function() {
                        if ($(this).is(':checked')) {
                            save['yes'].push($(this).attr('id'));
                        }
                        if ($(this).next().hasClass('unchecked')) {
                            save['no'].push($(this).attr('id'));
                        }
                    });

                    $.each($yesnos, function() {
                        if ($(this).is(':checked')) {
                            save['sum'] += $(this).data('points');
                        }
                    });
                    setTimeout(function() {
                        $.each($radios, function() {
                            if ($(this).is(':checked')) {
                                save['sum'] += 1 * $(this).val();
                            }
                        });
                        showSum30(save['sum']);

                        self.payload['Osteoporosis_slide30'] = save;
                    }, 200);

                });
            })
        },

        Osteoporosis_slide33: function() {
            var self = this,
                $scope = $('.checkboxes.Parker'),
                $inputs = $scope.find('input');

            if (self.payload['Osteoporosis_slide33']) {
                var save = self.payload['Osteoporosis_slide33'];
                $.each(save, function() {
                    $scope.find('#' + this).attr('checked', true);
                    $scope.find('label[for="' + this + '"]').addClass('checked selected');
                });
            };

            $.each($inputs, function() {
                $(this).on('change', function() {
                    var sum = 0;

                    var save = [];
                    $.each($inputs, function() {
                        if ($(this).is(':checked')) {
                            save.push($(this).attr('id'));
                        }
                    });
                    self.payload['Osteoporosis_slide33'] = save;

                    $.each($inputs, function() {
                        if ($(this).is(':checked')) {
                            sum += 1 * $(this).val();
                        }
                    });
                    $('#Ost_33_sum').html(sum);
                    if (sum <= 3) {
                        $('#Ost_33_result').addClass('highlight');
                    } else {
                        $('#Ost_33_result').removeClass('highlight');
                    }
                });
            })
        },

        Osteoporosis_slide31: function() {
            var self = this,
                $scope = $('.checkboxes.BarthelIndex'),
                $inputs = $scope.find('input');

            if (self.payload['Osteoporosis_slide31']) {
                var save = self.payload['Osteoporosis_slide31'];
                $.each(save, function() {
                    $scope.find('#' + this).attr('checked', true);
                    $scope.find('label[for="' + this + '"]').addClass('checked selected');
                });
            };

            $.each($inputs, function() {
                $(this).on('change', function() {
                    var sum = 0;

                    var save = [];
                    $.each($inputs, function() {
                        if ($(this).is(':checked')) {
                            save.push($(this).attr('id'));
                        }
                    });
                    self.payload['Osteoporosis_slide31'] = save;

                    $.each($inputs, function() {
                        if ($(this).is(':checked')) {
                            sum += 1 * $(this).val();
                        }
                    });
                    $('#Ost_31_sum').html(sum);
                    if (sum <= 40) {
                        $('#Ost_31_result').addClass('highlight');
                    } else {
                        $('#Ost_31_result').removeClass('highlight');
                    }
                });
            })
        },

        PainManagement_painScaleWithRange: function() {
            console.log('PainManagement_painScaleWithRange');

            try {
                $('#painScale, #painScale16, #painScale17, #painScale18, #painScale_PO_12, #painScale_PO_13').labeledslider({
                    max: 10,
                    tickInterval: 1,
                    slide: function(event, ui) {
                        console.log('ui: ', ui);
                        console.log('ui.value: '+ ui.value);
                        var scaleValue = ui.value;
                        $('.button').removeClass('highlight');
                        if (scaleValue <= 1.9) {
                            $('.button.b21').addClass('highlight');
                            $('.button.b16').addClass('highlight');
                        } else {
                            $('.button.a22').addClass('highlight');
                            $('.button.a17').addClass('highlight');
                        }
                    }
                });
            } catch (e) {
                console.log('Error: ', e);
            }


        },
        PainManagement_painScale: function() {
            console.log('PainManagement_painScale');
            $('#painScale, #painScale16, #painScale17, #painScale18, #painScale_PO_12, #painScale_PO_13').labeledslider({
                max: 10,
                tickInterval: 1,
                slide: function(event, ui) {
                    var scaleValue = ui.value;
                    $('.button').removeClass('highlight');
                    if (scaleValue <= 1.9) {
                        $('.button.b21').addClass('highlight');
                        $('.button.b16').addClass('highlight');
                    } else {
                        $('.button.a22').addClass('highlight');
                        $('.button.a17').addClass('highlight');
                    }
                }

            });
            $(".ui-slider-labels").css('display', 'none');
        }

    };
});