require(['jquery', 'hammer', 'manageContent', 'magicNumbers'], function($, Hammer, manageContent, magicNumbers) {

    /*
    // Initiate gesture-driven Drawer menu
    var navigationDrawer = new Snap({
        element: document.getElementById('content'),
        maxPosition: 240,
        minPosition: -240,
        flickThreshold: 50,
        disable: 'left'
        //easing: 'cubic-bezier(0.175, 0.885, 0.320, 1.275)',
        //hyperextensible: false,
        //transitionSpeed: 0.5
    });
    */

    var output = function(stuff) {
        if (magicNumbers.environment != 'live') {
            console.log(stuff);
        }
    }

    // init page (touchevents)
    var $content = $('#content'),
        naviHidden = true,
        halfWidth = function() { // it's a function, so i can resize the window and it still works
            return $content.outerWidth(true) / -2;
        },
        positionAside = function () { // this too
            return halfWidth() * 1.5; // only one quarter visible
        },
        css = true,
		hideNavi = function () {
            if (!naviHidden) {
                naviHidden = true;
                $('body').removeClass('menuIsOpen');

                if (css) {
                    $content.animate({ left: '0' }, 100, function () {
                      // FIXME michal.dabrowski - it seems to me that this code is has no effect.
                        $(this).css({ left: '100' });
                        $("[title=backgroundInfo]").css({position:'relative'})

                        // WORKAROUND forcing refeshing because
                        setTimeout(function () {
                          $("[title=backgroundInfo]").css({position:''})
                        }, 10);

                    });
                } else {
                    // Invoke Snap.js hide method
                    navigationDrawer.close();
                }
            }

		},
		showNavi = function () {
			naviHidden = false;
            $('body').addClass('menuIsOpen');

            if (css) {
			    $content.animate({ left: positionAside() + 'px' }, 75);
            } else {
                // Invoke Snap.js show method
                navigationDrawer.open('right');
            }

		};

    $('body').hammer()
        .on(magicNumbers.hammerEventTap, '.closebutton', function(event) {
            event.stopPropagation();
            hideNavi();
            manageContent.closeBackgroundInfo();
        })
        .on(magicNumbers.hammerEventTap, 'a', function(event){

            // weil der click-Event false returned wird das hier auch beim klicken getriggert
            output(this);

            if (!$(event.target).hasClass('mailto')) {
                event.stopPropagation();

                // #register-button, #feedback-button sollen ja weiter funktionieren
                // buttons ohne id sind die standard-text-links
                if ($(event.target).attr('id') === undefined) {
                    console.log($(event.target).attr('id'));
                    return false;
                }

                var $this = $(this),
                    href = $this.attr('href'),
                    script = $this.data('script');
                hideNavi();
                manageContent.linkClicked(href, script);
            }
        })
        .on('click', 'a', function (event) {
            if (!$(event.target).hasClass('mailto')) {
                event.stopPropagation();
                return false;
            }
        });

    output(magicNumbers);


    // every .button has to have a data-destination attribute
    $content.hammer().on(magicNumbers.hammerEventTap, '.button', function(event) { // dynamic items don't work within the Hammer-Object
        var $this = $(this);
        event.stopPropagation();
        hideNavi();

        var $parentColumn = $(event.target).parent();
        while (!$parentColumn.hasClass('column')) {
            $parentColumn = $parentColumn.parent();
        }
        var goBackToSlideNumber = $parentColumn.data('goback');

		if (!$this.hasClass('inactive')   ){//   && !$this.hasClass('Dashboard')) {
            if ($this.hasClass('toDashboard')) {
                manageContent.initial();
            } else if ($this.hasClass('specialButtonAddedLater')) {
                if ($this.hasClass('backToSlideOne')) {
                    manageContent.goBackToSlideNumber(1);
                }
            } else {
                if ($this.hasClass('Dashboard')) {
                    manageContent.firstStep($(this).data('destination'));
                } else {
                    // normal Button (or backgroundInfo) inside #content
                    manageContent.path($this, goBackToSlideNumber);
                }
            }
        }
    }).on('click', '.button', function (event) {
        event.stopPropagation();
        return false;
    });


    $('nav').hammer().on(magicNumbers.hammerEventTap, '.button', function(event) { // dynamic items don't work within the Hammer-Object
        var $this = $(this);
        event.stopPropagation();
		hideNavi();
        // console.log('nav')
        if ($this.hasClass('mainNavi')) {
            if ($this.hasClass('toDashboard')) {
                manageContent.initial();
            } else {
                manageContent.initial($this.data('destination'));
            }
        } else {
            manageContent.furtherReading($this.data('destination'));
        }
    });

    // header
    Hammer('#backbutton').on(magicNumbers.hammerEventTap, function(event) {
        event.stopPropagation();
		hideNavi();
        manageContent.back();
    });
    Hammer('#burgermenu').on(magicNumbers.hammerEventTap, function(event) {
        event.stopPropagation();
		manageContent.hideBreadcrumb();
        if (naviHidden) {
			showNavi();
            $('html, body').scrollTop(0);
    	} else {
			hideNavi();
		}
    });


    // breadcrumb navi
    Hammer('#toggleBreadcrumb').on(magicNumbers.hammerEventTap, function(event) {
        event.stopPropagation();
        manageContent.displayBreadcrumb();
    });
    Hammer('#breadcrumb-bg').on(magicNumbers.hammerEventTap, function() {
        manageContent.hideBreadcrumb();
    });
    // dynamic items don't work within the Hammer-Object
	// here, hammer() has to be called
    $('#breadcrumb').hammer().on(magicNumbers.hammerEventTap, 'li', function(event) {
        event.stopPropagation();
		hideNavi();
        manageContent.goBackToSlideNumber($(this).data('key'));
    });


    /*
    following all the functions that don't navigate
    but are only for effects on this slide
    (no manageContent involved)
    */

    // just for red/green checklists (no navigation)
    $content.hammer().on(magicNumbers.hammerEventTap, '.checkboxes label', function (event) { // dynamic items don't work within the Hammer-Object
      /*  var $this = $(this);
        if ($this.prev().is(':checked')) {
            $this.removeClass('checked').addClass('unchecked');
        } else {
            $this.addClass('checked').removeClass('unchecked');
        } */
    }).on('click', '.checkboxes label.checkbox', function (event) {
        event.preventDefault();
        return false;
    });

    // slide the content aside to show the navigation
    Hammer($content).on(magicNumbers.hammerEventTap, function() {
        hideNavi();
    });

    // definition lists have hidden definitions. after tapping <dt>, it slides to the left
    $content.hammer().on(magicNumbers.hammerEventTap, 'dl.unfold dt', function(event) { // dynamic items don't work within the Hammer-Object
        event.stopPropagation();
        var $this = $(this);

        if ($this.data('unfolded') === 'true') {
            $this.animate({ marginLeft: '0' }).data('unfolded', 'false');
        } else {
            var width = -1 * $this.width();// + 30;
            $this.animate({ marginLeft: width + 'px' }).data('unfolded', 'true');
        }

        $this.next().off().on(magicNumbers.hammerEventTap, function(event) {
            $(this).prev().animate({ marginLeft: '0' }).data('unfolded', 'false');
        });

    });

    // just for security, if the splashscreen doesn't hide automatically
    Hammer('#splashscreen').on(magicNumbers.hammerEventTap, function () {
        $(this).hide();
    });

});
